#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <random>
#include <chrono>
using namespace std;
using ll = long long;
using lld = long double;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif;
    ll N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    vector<pair<ll, ll>> b(n);
    for (int i = 0; i < m; ++i)
        cin >> b[i].first >> b[i].second;
    while (q--) {
        ll x, y;
        cin >> x >> y;
        cout << "Yes\n";
    }
}